/*
 * Copyright (C) 2016 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.thema.lucsim.gui.generator.dt;

import java.util.ArrayList;
import java.util.List;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import weka.classifiers.trees.HoeffdingTree;

/**
 * Window dialog which prompts the user for the advanced parameters to use to 
 * build an Hoeffding tree. 
 * Said user is able to choose the following options (default values
 * are bracketed):<br>
 * - the leaf prediction strategy (naive Bayes adaptative);<br>
 * - the split criterion (info gain split);<br>
 * - the split confidence (1.0e-7);<br>
 * - the Hoeffding tie threshold (0.05);<br>
 * - the minimum fraction of info weight gain (0.01);<br>
 * - the grace period (200.0);<br>
 * - the naive Bayes prediction threshold (0.0);<br>
 * More info can be found at: 
 * http://weka.sourceforge.net/doc.dev/weka/classifiers/trees/HoeffdingTree.html
 */
public class HoeffdingTreeSettingsDialog extends javax.swing.JDialog {

    private List<Double> params;

    /**
     * Creates new form DecisionTreeSettingsDialog.
     * @param parent parent Dialog
     * @param params list of parameters, can be empty but cannot be null
     */
    public HoeffdingTreeSettingsDialog(JDialog parent, List<Double> params) {
        super(parent, true);
        this.params = params;
        setLocationRelativeTo(parent);
        setResizable(false);
        initComponents();
        setTips();
        
        // TODO set UI depending on params
    }

    private void setTips() {
        HoeffdingTree ht = new HoeffdingTree();
        labelLeafPredictionStrategy.setToolTipText(ht.leafPredictionStrategyTipText());
        labelSplitCriterion.setToolTipText(ht.splitCriterionTipText());
        labelSplitConfidence.setToolTipText(ht.splitConfidenceTipText());
        labelHoeffdingTieThreshold.setToolTipText((ht.hoeffdingTieThresholdTipText()));
        labelMinimumFractionOfWeightGain.setToolTipText((ht.minimumFractionOfWeightInfoGainTipText()));
        labelGracePeriod.setToolTipText((ht.gracePeriodTipText()));
        labelNaivesBayesPredictionThreshold.setToolTipText((ht.naiveBayesPredictionThresholdTipText()));
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        comboBoxLeafPredictionStrategy = new javax.swing.JComboBox<String>();
        comboBoxSplitCriterion = new javax.swing.JComboBox<String>();
        textFieldGracePeriod = new javax.swing.JTextField();
        labelSettings = new javax.swing.JLabel();
        textFieldHoeffdingTieThreshold = new javax.swing.JTextField();
        labelGracePeriod = new javax.swing.JLabel();
        textFieldNaivesBayesPredictionThreshold = new javax.swing.JTextField();
        labelHoeffdingTieThreshold = new javax.swing.JLabel();
        textFieldSplitConfidence = new javax.swing.JTextField();
        labelNaivesBayesPredictionThreshold = new javax.swing.JLabel();
        buttonOK = new javax.swing.JButton();
        labelMinimumFractionOfWeightGain = new javax.swing.JLabel();
        textFieldMinimumFractionOfWeightInfoGain = new javax.swing.JTextField();
        labelLeafPredictionStrategy = new javax.swing.JLabel();
        labelTip = new javax.swing.JLabel();
        labelSplitCriterion = new javax.swing.JLabel();
        labelSplitConfidence = new javax.swing.JLabel();
        cancelButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Tree settings");

        comboBoxLeafPredictionStrategy.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Majority class", "Naive Bayes", "Naive Bayes adaptative" }));
        comboBoxLeafPredictionStrategy.setSelectedIndex(2);
        comboBoxLeafPredictionStrategy.setName("comboBoxLeafPredictionStrategy"); // NOI18N

        comboBoxSplitCriterion.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Gini split", "Info gain split" }));
        comboBoxSplitCriterion.setSelectedIndex(1);
        comboBoxSplitCriterion.setName("comboBoxSplitCriterion"); // NOI18N

        textFieldGracePeriod.setText("200.0");
        textFieldGracePeriod.setName("textFieldGracePeriod"); // NOI18N

        labelSettings.setFont(new java.awt.Font("Arial", 1, 18)); // NOI18N
        labelSettings.setText("Settings");
        labelSettings.setName("labelSettings"); // NOI18N

        textFieldHoeffdingTieThreshold.setText("0.05");
        textFieldHoeffdingTieThreshold.setName("textFieldHoeffdingTieThreshold"); // NOI18N

        labelGracePeriod.setText("gracePeriod");
        labelGracePeriod.setName("labelGracePeriod"); // NOI18N

        textFieldNaivesBayesPredictionThreshold.setText("0.0");
        textFieldNaivesBayesPredictionThreshold.setName("textFieldNaivesBayesPredictionThreshold"); // NOI18N

        labelHoeffdingTieThreshold.setText("hoeffdingTieThreshold");
        labelHoeffdingTieThreshold.setName("labelHoeffdingTieThreshold"); // NOI18N

        textFieldSplitConfidence.setText("1.0E-7");
        textFieldSplitConfidence.setName("textFieldSplitConfidence"); // NOI18N

        labelNaivesBayesPredictionThreshold.setText("naiveBayesPredictionThreshold");
        labelNaivesBayesPredictionThreshold.setName("labelNaivesBayesPredictionThreshold"); // NOI18N

        buttonOK.setText("OK");
        buttonOK.setName("buttonOK"); // NOI18N
        buttonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonOKActionPerformed(evt);
            }
        });

        labelMinimumFractionOfWeightGain.setText("minimumFractionOfWeightInfoGain");
        labelMinimumFractionOfWeightGain.setName("labelMinimumFractionOfWeightGain"); // NOI18N

        textFieldMinimumFractionOfWeightInfoGain.setText("0.01");
        textFieldMinimumFractionOfWeightInfoGain.setName("textFieldMinimumFractionOfWeightInfoGain"); // NOI18N

        labelLeafPredictionStrategy.setText("leafPredictionStrategy");
        labelLeafPredictionStrategy.setName("labelLeafPredictionStrategy"); // NOI18N

        labelTip.setFont(new java.awt.Font("Tahoma", 2, 11)); // NOI18N
        labelTip.setText("(hover over the components to get a tip)");
        labelTip.setName("labelTip"); // NOI18N

        labelSplitCriterion.setText("splitCriterion");
        labelSplitCriterion.setName("labelSplitCriterion"); // NOI18N

        labelSplitConfidence.setText("splitConfidence");
        labelSplitConfidence.setName("labelSplitConfidence"); // NOI18N

        cancelButton.setText("Cancel");
        cancelButton.setName("cancelButton"); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(12, 12, 12)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(labelSettings)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(labelTip))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(labelMinimumFractionOfWeightGain)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(textFieldMinimumFractionOfWeightInfoGain))))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(27, 27, 27)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(labelLeafPredictionStrategy)
                            .addComponent(labelHoeffdingTieThreshold)
                            .addComponent(labelSplitConfidence)
                            .addComponent(labelSplitCriterion)
                            .addComponent(labelGracePeriod)
                            .addComponent(labelNaivesBayesPredictionThreshold))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(textFieldHoeffdingTieThreshold, javax.swing.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
                            .addComponent(textFieldSplitConfidence, javax.swing.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
                            .addComponent(comboBoxSplitCriterion, 0, 154, Short.MAX_VALUE)
                            .addComponent(textFieldGracePeriod, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
                            .addComponent(textFieldNaivesBayesPredictionThreshold, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 154, Short.MAX_VALUE)
                            .addComponent(comboBoxLeafPredictionStrategy, 0, 154, Short.MAX_VALUE)))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(buttonOK, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(cancelButton)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelSettings)
                    .addComponent(labelTip))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(labelLeafPredictionStrategy)
                    .addComponent(comboBoxLeafPredictionStrategy, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelSplitCriterion)
                    .addComponent(comboBoxSplitCriterion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelSplitConfidence)
                    .addComponent(textFieldSplitConfidence, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelHoeffdingTieThreshold)
                    .addComponent(textFieldHoeffdingTieThreshold, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelMinimumFractionOfWeightGain)
                    .addComponent(textFieldMinimumFractionOfWeightInfoGain, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelGracePeriod)
                    .addComponent(textFieldGracePeriod, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelNaivesBayesPredictionThreshold)
                    .addComponent(textFieldNaivesBayesPredictionThreshold, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 12, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonOK)
                    .addComponent(cancelButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void buttonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOKActionPerformed
        if (textFieldSplitConfidence.getText().equals("")
            || textFieldHoeffdingTieThreshold.getText().equals("")
            || textFieldMinimumFractionOfWeightInfoGain.getText().equals("")
            || textFieldGracePeriod.getText().equals("")
            || textFieldNaivesBayesPredictionThreshold.getText().equals("")) {
            JOptionPane.showMessageDialog(this, "At least one field is not filled.");
        }
        else {
            params.clear();
            params.add((double) comboBoxLeafPredictionStrategy.getSelectedIndex());
            params.add((double) comboBoxSplitCriterion.getSelectedIndex());
            params.add(Double.valueOf(textFieldSplitConfidence.getText()));
            params.add(Double.valueOf(textFieldHoeffdingTieThreshold.getText()));
            params.add(Double.valueOf(textFieldMinimumFractionOfWeightInfoGain.getText()));
            params.add(Double.valueOf(textFieldGracePeriod.getText()));
            params.add(Double.valueOf(textFieldNaivesBayesPredictionThreshold.getText()));

            setVisible(false);
            dispose();
        }
    }//GEN-LAST:event_buttonOKActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonOK;
    private javax.swing.JButton cancelButton;
    private javax.swing.JComboBox<String> comboBoxLeafPredictionStrategy;
    private javax.swing.JComboBox<String> comboBoxSplitCriterion;
    private javax.swing.JLabel labelGracePeriod;
    private javax.swing.JLabel labelHoeffdingTieThreshold;
    private javax.swing.JLabel labelLeafPredictionStrategy;
    private javax.swing.JLabel labelMinimumFractionOfWeightGain;
    private javax.swing.JLabel labelNaivesBayesPredictionThreshold;
    private javax.swing.JLabel labelSettings;
    private javax.swing.JLabel labelSplitConfidence;
    private javax.swing.JLabel labelSplitCriterion;
    private javax.swing.JLabel labelTip;
    private javax.swing.JTextField textFieldGracePeriod;
    private javax.swing.JTextField textFieldHoeffdingTieThreshold;
    private javax.swing.JTextField textFieldMinimumFractionOfWeightInfoGain;
    private javax.swing.JTextField textFieldNaivesBayesPredictionThreshold;
    private javax.swing.JTextField textFieldSplitConfidence;
    // End of variables declaration//GEN-END:variables
}
